typedef Future<TResult> CallFun<TArgs, TResult>(TArgs args);
typedef TOut MapFun<TArgs, TIn, TOut>(TArgs args, TIn data);
typedef TOut ExceptionMapFun<TArgs, TOut>(TArgs args, dynamic e,
    [StackTrace t]);

typedef Future<void> EffectFun<TArgs, TResult>(TArgs args, TResult result);
typedef Future<void> ExceptionEffectFun<TArgs>(TArgs args, dynamic e,
    [StackTrace t]);

typedef void EventHandler<TEvent>(TEvent event);
typedef dynamic DynamicEventHandler<TEvent>(TEvent event);
typedef Future<void> AsyncEventHandler<TEvent>(TEvent event);
